var MAX_LANE = 12;

var socketId;
var index=0;
var appWin1 = null;
var appWin2 = null;
var seri = new Array(MAX_LANE);

var i;

for( i=0;i<MAX_LANE;i++ ){
	
	seri[i] = new Object();
	seri[i].lane=0;
	seri[i].spno=0;
	seri[i].nextno=0;
	seri[i].price=0;
	seri[i].slamp=0;
	seri[i].andon=0;
	seri[i].tflg=0;
	seri[i].lamp1=0;
	seri[i].lamp2=0;
	seri[i].lamp3=0;
	seri[i].sheet=0;
}

// Handle the "onReceive" event.
var onReceive = function(info) {
  if (info.socketId !== socketId)
    return;

 // var requestText = ab2str(info.data);
  var pkt = new Uint8Array(info.data);
  
  var requestText;
  var mode;
  var cmd1 = getUint16( pkt, 0 );
  var cmd2 = getUint16( pkt, 2 );
  var cnt = getUint16( pkt, 4 );
  var rsv = getUint16( pkt, 6 );
  var lane = getUint16( pkt, 16 );
  var spno;
  var nextno;
  var price;
  var slamp;
  var andon;
  var tflg;


  mode='0';
  if( pkt.length == 88 ){	//価格2
	if( cmd1==26 ){
		mode='2';
		if( (pkt[32] & 0x80 ) == 0x80 ){
			//Start
			if( (pkt[34] & 0x80) == 0x80 ){
				seri[lane].tflg = 1;
			}else{
				seri[lane].tflg = 0;
			}
			seri[lane].slamp=1;		//スタート
		}else{
			seri[lane].slamp=0;		//消す
		}
		if( (pkt[33] & 0x01 ) == 0x01 ){
			seri[lane].slamp=2;		//決定
			seri[lane].sheet = getUint32( pkt, 76 );
			if( seri[lane].sheet>=9901 &&  seri[lane].sheet<=9999 ){
				seri[lane].slamp=5;	//外部落札
			}
		}else if( (pkt[33] & 0x02 ) == 0x02 ){
			seri[lane].slamp=3;		//流れ
		}else if( (pkt[33] & 0x80 ) == 0x80 ){
			//売り切り
			seri[lane].slamp=4;		//売り切り
		}
		seri[lane].andon=0;
		if( (pkt[34] & 0x01 ) == 0x01 ){
			seri[lane].andon=1;	//赤
		}else if( (pkt[34] & 0x02 ) == 0x02 ){
			seri[lane].andon=2;	//黄色
		}else if( (pkt[34] & 0x04 ) == 0x04 ){
			seri[lane].andon=3;	//緑
		}
		seri[lane].spno = getUint32( pkt, 20 );
		seri[lane].price = getUint32( pkt, 24 );
	}
  }else{
	//60
	if( cmd1==15 ){
		mode='1';			//価格1
		if( pkt[20]=='1' ){
			seri[lane].tflg = 1;
		}else{
			seri[lane].tflg = 0;
		}
		seri[lane].spno = getUint32( pkt, 36 );
		seri[lane].price = getUint32( pkt, 40 );
		seri[lane].nextno = getUint32( pkt, 44 );
	}
  }
  
  if( mode!='0' ){
	if( price > 900000 ) price = -1;
    requestText = '[MODE:'+mode+'('+ pkt.length +')], LANE:'+ lane +', SPNO:' +seri[lane].spno+', PRICE:' +seri[lane].price;
    
  }
 //var requestText = '123';
 
 
  strLog = index.toString()+':'+requestText+'<br />';

	/*function udpRecv( winid, lane, spno, nextno, price, slamp, andonlamp, tflg )	*/  
  console.log(strLog);
  if( appWin1 )
  	if( appWin1.contentWindow )
	  appWin1.contentWindow.udpRecv(1, lane, seri[lane].spno, seri[lane].nextno, seri[lane].price, seri[lane].slamp, seri[lane].andon, seri[lane].tflg );
  if( appWin2 )
  	if( appWin2.contentWindow )
	  appWin1.contentWindow.udpRecv(2, lane, seri[lane].spno, seri[lane].nextno, seri[lane].price, seri[lane].slamp, seri[lane].andon, seri[lane].tflg );
 /*
  test.scrollTop = test.scrollHeight - test.clientHeight;

  var span = document.createElement("span");
//  span.textContent = strLog;
  span.innerHTML = strLog;
  test.appendChild(span);
  */
  index++;
};

function timeCheck(){
	var std = new Date();
	return std.getTime();
}

function timeCheckFuture( nSec ){
	return timeCheck() + nSec;
}

function getString( buf, idx, len  ){
	var r = "";
	for( ggi=idx;ggi<idx+len;ggi++ ){				//>
		r+=String.fromCharCode(buf[ggi]);
	}
	return r;
}

function getArray( buf, idx, len ){
	var n=0;
	var r = new Array(len);
	for( ggi=idx;ggi<idx+len;ggi++ ){				//>
		r[n]=buf[ggi];
		if( buf[ggi] == 0 ) break;
		n++;
	}
	return r;
}

function getStrArray( buf, idx, len ){
	var n=0;
	var r = new Array(len);
	for( i=idx;i<idx+len;i++ ){						//>
		r[n]=String.fromCharCode(buf[i]);
		if( buf[i] == 0 ) break;
		n++;
	}
	return r;
}

//shortデータをバイナリ配列から取得する関数
function getUint16( buf, idx ){
	var r;
	r = buf[idx];
	r+=(buf[idx+1]*0x100);
	return r;
}

//intデータをバイナリ配列から取得する関数
function getUint32( buf, idx ){
	var r;
	r = buf[idx];
	r+=(buf[idx+1]*0x100);
	r+=(buf[idx+2]*0x10000);
	r+=(buf[idx+3]*0x1000000);
	return r;
}

function setUint32( buf, pidx, val ){
	var byteArray = new Uint8Array(4);
	var rd=val;
	byteArray[0]=rd % 0x100;
	rd-=byteArray[0];
	rd/=0x100;
	byteArray[1]=rd % 0x100;
	rd-=byteArray[1];
	rd/=0x100;
	byteArray[2]=rd % 0x100;
	rd-=byteArray[2];
	rd/=0x100;
	byteArray[3]=rd % 0x100;

	buf[pidx]=byteArray[0];
	buf[pidx+1]=byteArray[1];
	buf[pidx+2]=byteArray[2];
	buf[pidx+3]=byteArray[3];
}

function setUint16( buf, pidx, val ){
	var byteArray = new Uint8Array(2);
	var rd=val;
	byteArray[0]=rd % 0x100;
	rd-=byteArray[0];
	rd/=0x100;
	byteArray[1]=rd % 0x100;

	buf[pidx]=byteArray[0];
	buf[pidx+1]=byteArray[1];
}

function getBytes(strSrc){
    var ret = new Uint8Array( strSrc.length );
    for(ggi = 0; ggi < strSrc.length; ggi++){		//>
		ret[ggi]=strSrc.charCodeAt(ggi);
    }
    return ret;
}

function terminate( appId ){
	console.log('terminate');
	if( appId == 1 ) appWin2.close();
	if( appId == 2 ) appWin1.close();
	chrome.sockets.udp.onReceive.removeListener(onReceive);
	chrome.sockets.udp.close( socketId );
}

function stringToArrayBuffer(string) {
	var buffer = new ArrayBuffer(string.length);
	var bufView = new Uint8Array(buffer);
	for (var i=0; i < string.length; i++) {
		bufView[i] = string.charCodeAt(i);
	}
	return buffer;
}

function sendPriceStartRequest()
{
	var org_data="K00011";
	var data = stringToArrayBuffer(org_data);

	chrome.sockets.udp.send( socketId, data, "10.10.100.165", 10001, function (sendInfo) {
		if (sendInfo.resultCode < 0) {
			console.log(chrome.runtime.lastError.message);
		}
	});
}

function InitialTimer(){
	sendPriceStartRequest();
	setTimeout(InitialTimer,1000);
}

chrome.app.runtime.onLaunched.addListener(function() {

	var options1 = {
		'id': 'DISP1',
		left: 0,
		top: 0,
		width: 1920,
		height: 1080,
//		state:"fullscreen",
		resizable: false,
		bounds: {
			left: 0,
			top: 0,
			width: 1920,
			height: 1080
		},
		frame: 'none'
	};
	
	chrome.app.window.create('applications.html', (options1), function(appWin){
		appWin1=appWin;
		appWin.onClosed.addListener(function() { terminate(1); }); 
	});
	
	
	var options2 = {
		'id': 'DISP2',
		left: 1920,
		top: 0,
		width: 1920,
		height: 1080,
//		state:"fullscreen",
		resizable: false,
		bounds: {
			left: 1920,
			top: 0,
			width: 1920,
			height: 1080
		},
		frame: 'none'
	};
	chrome.app.window.create('applications.html', (options2), function(appWin){
		appWin2=appWin;
		appWin.onClosed.addListener(function() { terminate(2); }); 
	});

	// Create the Socket
	chrome.sockets.udp.create({}, function(socketInfo) {
	  socketId = socketInfo.socketId;
	  // Setup event handler and bind socket.
	  chrome.sockets.udp.onReceive.addListener(onReceive);
	  chrome.sockets.udp.bind(socketId,
	    "0.0.0.0", 10020, function(result) {
	      if (result < 0) {
	        console.log("Error binding socket.");
	        return;
	      }else{
	        console.log("binding socket.");
//	        setTimeout(InitialTimer,1000);
	      }
	  });
	});
	
	chrome.power.requestKeepAwake("display");
});

chrome.app.runtime.onRestarted.addListener(function() {
	chrome.power.releaseKeepAwake();
	console.log("stop");
	
});